<script setup lang="ts">
import LabeledInput from "./components/LabeledInput.vue";
import { reactive } from "vue";
import ShowcaseTitle from "./ShowcaseTitle.vue";
import type { MaterialIconName } from "./components/MaterialIcon";

const fieldsParams = reactive([
  { id: "input-1-1", labelText: "Label", placeholder: "Placeholder" },
  {
    id: "input-2-1",
    labelText: "Label",
    placeholder: "Placeholder",
  },
  {
    id: "input-3-1",
    labelText: "Label",
    placeholder: "Placeholder",
  },
  {
    id: "input-4-1",
    labelText: "Label",
    placeholder: "Placeholder",
    helperText: "Some interesting text",
  },
  {
    id: "input-4-2",
    labelText: "Label",
    placeholder: "Placeholder",
    helperText: "Some interesting text",
  },
  {
    id: "input-5-1",
    labelText: "Label",
    placeholder: "Placeholder",
    startIcon: "phone" as MaterialIconName,
  },
  {
    id: "input-5-2",
    labelText: "Label",
    placeholder: "Placeholder",
    endIcon: "lock" as MaterialIconName,
  },
  {
    id: "input-6-1",
    labelText: "Label",
    placeholder: "Placeholder",
    modelValue: "Text",
  },
  {
    id: "input-7-1",
    labelText: "Label",
    placeholder: "Placeholder",
    small: true,
  },
  {
    id: "input-8-1",
    labelText: "Label",
    placeholder: "Placeholder",
    fullwidth: true,
  },
  {
    id: "input-9-1",
    labelText: "Label",
    placeholder: "Placeholder",
    multiline: true,
    rows: 4,
  },
]);
</script>

<template>
  <main class="main">
    <h1 class="heading">Inputs</h1>
    <p class="description">All text and numeric fields are editable.</p>
    <div class="inputs">
      <div class="inputs__row">
        <section class="showcase">
          <ShowcaseTitle
            class="showcase__heading"
            v-model:id="fieldsParams[0].id"
            v-model:labelText="fieldsParams[0].labelText"
            v-model:placeholder="fieldsParams[0].placeholder"
          />
          <LabeledInput
            :attributes="{
              id: fieldsParams[0].id,
              labelText: fieldsParams[0].labelText,
              placeholder: fieldsParams[0].placeholder,
            }"
          />
        </section>
      </div>

      <div class="inputs__row">
        <section class="showcase">
          <ShowcaseTitle
            class="showcase__heading"
            v-model:id="fieldsParams[1].id"
            v-model:labelText="fieldsParams[1].labelText"
            v-model:placeholder="fieldsParams[1].placeholder"
            :error="true"
          />
          <LabeledInput
            :attributes="{
              id: fieldsParams[1].id,
              labelText: fieldsParams[1].labelText,
              placeholder: fieldsParams[1].placeholder,
              error: true,
            }"
          />
        </section>
      </div>

      <div class="inputs__row">
        <section class="showcase">
          <ShowcaseTitle
            class="showcase__heading"
            v-model:id="fieldsParams[2].id"
            v-model:labelText="fieldsParams[2].labelText"
            v-model:placeholder="fieldsParams[2].placeholder"
            :disabled="true"
          />
          <LabeledInput
            :attributes="{
              id: fieldsParams[2].id,
              labelText: fieldsParams[2].labelText,
              placeholder: fieldsParams[2].placeholder,
              disabled: true,
            }"
          />
        </section>
      </div>

      <div class="inputs__row">
        <section class="showcase">
          <ShowcaseTitle
            class="showcase__heading"
            v-model:id="fieldsParams[3].id"
            v-model:labelText="fieldsParams[3].labelText"
            v-model:placeholder="fieldsParams[3].placeholder"
            v-model:helperText="fieldsParams[3].helperText"
          />
          <LabeledInput
            :attributes="{
              id: fieldsParams[3].id,
              labelText: fieldsParams[3].labelText,
              placeholder: fieldsParams[3].placeholder,
              helperText: fieldsParams[3].helperText,
            }"
          />
        </section>

        <section class="showcase">
          <ShowcaseTitle
            class="showcase__heading"
            v-model:id="fieldsParams[4].id"
            v-model:labelText="fieldsParams[4].labelText"
            v-model:placeholder="fieldsParams[4].placeholder"
            :error="true"
            v-model:helperText="fieldsParams[4].helperText"
          />
          <LabeledInput
            :attributes="{
              id: fieldsParams[4].id,
              labelText: fieldsParams[4].labelText,
              placeholder: fieldsParams[4].placeholder,
              error: true,
              helperText: fieldsParams[4].helperText,
            }"
          />
        </section>
      </div>

      <div class="inputs__row">
        <section class="showcase">
          <ShowcaseTitle
            class="showcase__heading"
            v-model:id="fieldsParams[5].id"
            v-model:labelText="fieldsParams[5].labelText"
            v-model:placeholder="fieldsParams[5].placeholder"
            v-model:startIcon="fieldsParams[5].startIcon"
          />
          <LabeledInput
            :attributes="{
              id: fieldsParams[5].id,
              labelText: fieldsParams[5].labelText,
              placeholder: fieldsParams[5].placeholder,
              startIcon: fieldsParams[5].startIcon,
            }"
          />
        </section>

        <section class="showcase">
          <ShowcaseTitle
            class="showcase__heading"
            v-model:id="fieldsParams[6].id"
            v-model:labelText="fieldsParams[6].labelText"
            v-model:placeholder="fieldsParams[6].placeholder"
            v-model:endIcon="fieldsParams[6].endIcon"
          />
          <LabeledInput
            :attributes="{
              id: fieldsParams[6].id,
              labelText: fieldsParams[6].labelText,
              placeholder: fieldsParams[6].placeholder,
              endIcon: fieldsParams[6].endIcon,
            }"
          />
        </section>
      </div>

      <div class="inputs__row">
        <section class="showcase">
          <ShowcaseTitle
            class="showcase__heading"
            v-model:id="fieldsParams[7].id"
            v-model:labelText="fieldsParams[7].labelText"
            v-model:placeholder="fieldsParams[7].placeholder"
            v-model:modelValue="fieldsParams[7].modelValue"
          />
          <LabeledInput
            :attributes="{
              id: fieldsParams[7].id,
              labelText: fieldsParams[7].labelText,
              placeholder: fieldsParams[7].placeholder,
              modelValue: fieldsParams[7].modelValue,
            }"
          />
        </section>
      </div>

      <div class="inputs__row">
        <section class="showcase">
          <ShowcaseTitle
            class="showcase__heading"
            v-model:id="fieldsParams[8].id"
            v-model:labelText="fieldsParams[8].labelText"
            v-model:placeholder="fieldsParams[8].placeholder"
            :small="fieldsParams[8].small"
          />
          <LabeledInput
            :attributes="{
              id: fieldsParams[8].id,
              labelText: fieldsParams[8].labelText,
              placeholder: fieldsParams[8].placeholder,
              small: fieldsParams[8].small,
            }"
          />
        </section>
      </div>

      <div class="inputs__row">
        <section class="showcase">
          <ShowcaseTitle
            class="showcase__heading"
            v-model:id="fieldsParams[9].id"
            v-model:labelText="fieldsParams[9].labelText"
            v-model:placeholder="fieldsParams[9].placeholder"
            :fullwidth="fieldsParams[9].fullwidth"
          />
          <LabeledInput
            :attributes="{
              id: fieldsParams[9].id,
              labelText: fieldsParams[9].labelText,
              placeholder: fieldsParams[9].placeholder,
              fullwidth: fieldsParams[9].fullwidth,
            }"
          />
        </section>
      </div>

      <div class="inputs__row">
        <section class="showcase">
          <ShowcaseTitle
            class="showcase__heading"
            v-model:id="fieldsParams[10].id"
            v-model:labelText="fieldsParams[10].labelText"
            v-model:placeholder="fieldsParams[10].placeholder"
            :multiline="fieldsParams[10].multiline"
            v-model:rows="fieldsParams[10].rows"
          />
          <LabeledInput
            :attributes="{
              id: fieldsParams[10].id,
              labelText: fieldsParams[10].labelText,
              placeholder: fieldsParams[10].placeholder,
              multiline: fieldsParams[10].multiline,
              rows: fieldsParams[10].rows,
            }"
          />
        </section>
      </div>
    </div>

    <p class="icons-source">
      <span>Icons: </span>
      <a
        href="https://material.io/resources/icons/?style=round"
        class="icons-source__link"
        >https://material.io/resources/icons/?style=round</a
      >
    </p>
  </main>
</template>

<style lang="scss">
@import "./assets/base";

.main {
  padding: 3rem 8rem calc(6rem + env(safe-area-inset-bottom));

  @media only screen and (max-width: 46.875em) {
    padding: 2rem 6rem calc(4rem + env(safe-area-inset-bottom));
  }

  @media only screen and (max-width: 37.5em) {
    padding: 1rem 4rem calc(2rem + env(safe-area-inset-bottom));
  }

  @media only screen and (max-width: 18.75em) {
    padding: 1rem 1.5rem calc(2rem + env(safe-area-inset-bottom));
  }
}

.heading {
  font-family: var(--font-default);
  font-size: 2.4rem;
  font-weight: 500;
  line-height: 1.5;
  color: #333;
  margin-bottom: 1.6rem;
}

.description {
  font-family: var(--font-default);
  font-size: 1.6rem;
  font-weight: 500;
  line-height: 1.45;
  color: #333;
  margin-bottom: 6.5rem;
}

.inputs {
  display: flex;
  flex-direction: column;
  gap: 10rem;
  margin-bottom: 4.2rem;
  font-family: var(--font-button);
  font-size: 1.8rem;
  font-weight: 500;
  line-height: 1.45;

  @media only screen and (max-width: 46.875em) {
    gap: 8rem;
  }

  @media only screen and (max-width: 18.75em) {
    gap: 6rem;
  }

  &__row {
    display: flex;
    align-items: flex-end;
    flex-wrap: wrap;
    column-gap: 6rem;
    row-gap: 4rem;

    @media only screen and (max-width: 46.875em) {
      column-gap: 4rem;
      row-gap: 3rem;
    }

    @media only screen and (max-width: 37.5em) {
      column-gap: 2rem;
      row-gap: 2rem;
    }

    @media only screen and (max-width: 18.75em) {
      column-gap: 1rem;
      row-gap: 1rem;
    }
  }
}

.showcase {
  flex: 0;

  &__heading {
    font-family: var(--font-mono);
    font-size: 1.6rem;
    line-height: 1;
    color: #333;
    margin-bottom: 1.6rem;
  }
}

.icons-source {
  font-family: var(--font-mono);
  font-size: 1.2rem;
  line-height: 1;
  color: #333;

  &__link {
    text-decoration: none;

    &:visited {
      color: #333;
    }

    &:hover,
    &:focus,
    &:active {
      outline: none;
      text-decoration: underline;
      text-decoration-thickness: 0.2rem;
    }
  }
}
</style>
